from __future__ import annotations

from collections.abc import Mapping
from typing import Any, TypeVar

from attrs import define as _attrs_define
from attrs import field as _attrs_field

from ..types import UNSET, Unset

T = TypeVar("T", bound="LegacytypesNoticeProgress")


@_attrs_define
class LegacytypesNoticeProgress:
    """
    Attributes:
        field_id (str | Unset):
        date (str | Unset):
        file (str | Unset):
        name (str | Unset):
        opened (int | Unset):
        total (int | Unset):
    """

    field_id: str | Unset = UNSET
    date: str | Unset = UNSET
    file: str | Unset = UNSET
    name: str | Unset = UNSET
    opened: int | Unset = UNSET
    total: int | Unset = UNSET
    additional_properties: dict[str, Any] = _attrs_field(init=False, factory=dict)

    def to_dict(self) -> dict[str, Any]:
        field_id = self.field_id

        date = self.date

        file = self.file

        name = self.name

        opened = self.opened

        total = self.total

        field_dict: dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({})
        if field_id is not UNSET:
            field_dict["_id"] = field_id
        if date is not UNSET:
            field_dict["date"] = date
        if file is not UNSET:
            field_dict["file"] = file
        if name is not UNSET:
            field_dict["name"] = name
        if opened is not UNSET:
            field_dict["opened"] = opened
        if total is not UNSET:
            field_dict["total"] = total

        return field_dict

    @classmethod
    def from_dict(cls: type[T], src_dict: Mapping[str, Any]) -> T:
        d = dict(src_dict)
        field_id = d.pop("_id", UNSET)

        date = d.pop("date", UNSET)

        file = d.pop("file", UNSET)

        name = d.pop("name", UNSET)

        opened = d.pop("opened", UNSET)

        total = d.pop("total", UNSET)

        legacytypes_notice_progress = cls(
            field_id=field_id,
            date=date,
            file=file,
            name=name,
            opened=opened,
            total=total,
        )

        legacytypes_notice_progress.additional_properties = d
        return legacytypes_notice_progress

    @property
    def additional_keys(self) -> list[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
